// $Date:: 2009-08-23 19:41:38 +0900#$
// $Rev: 2 $


#pragma once
#include <windows.h>
#include "avisynth.h"

//==============================================================================
// MoveChroma
//==============================================================================
class MoveChroma : public GenericVideoFilter
{
protected:
    unsigned int Height ;
    unsigned int Width ;
    int Cb ;
    int Cr ;

public:
	MoveChroma (PClip _child, int cb, int cr, IScriptEnvironment* env);
};

class MoveChromaYV12 : public MoveChroma
{
private:
    void Move ( BYTE* pSrc , const unsigned int nSrcPitch , const int nMove );

public:
    MoveChromaYV12 (PClip _child, int cb, int cr, IScriptEnvironment* env) : MoveChroma ( _child, cb, cr, env) {} ;
    PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env) ;
};

class MoveChromaYUY2 : public MoveChroma
{
private:
    void Move ( BYTE* pSrc , const unsigned int nSrcPitch , const int nMove );

public:
	MoveChromaYUY2 (PClip _child, int cb, int cr, IScriptEnvironment* env) : MoveChroma ( _child, cb, cr, env) {} ;;
    PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env) ;
};
